<?php

// Задаем ID нужной категории (родительской)
$parent_cat_id = 3697; // РФО

// Получим ID подкатегорий
$subcats = get_categories( array(
    'child_of'   => $parent_cat_id,
    'hide_empty' => false,
) );

// Собираем все ID: родительская + подкатегории
$category_ids = array( $parent_cat_id );
foreach ( $subcats as $cat ) {
    $category_ids[] = $cat->term_id;
}


/**
// Получаем текущий день месяца
$current_day = date('j'); // день месяца без ведущего нуля

// Формируем date_query в зависимости от дня месяца
if ($current_day <= 5) {
    // Первые 5 дней месяца - показываем посты за последние 30 дней
    $date_query = array(
        array(
            'after' => ' month ago',
            'inclusive' => true,
        ),
    );
} else {
    // После 5 числа - показываем посты за текущий календарный месяц
    $current_month = date('n');
    $current_year = date('Y');
    
    $date_query = array(
        array(
            'year'  => $current_year,
            'month' => $current_month,
        ),
    );
}

 */

$date_query = array(
    array(
        'after' => '30 days ago',
        'inclusive' => true,
    ),
);

// Получаем 3 случайных поста из этих категорий
$params = array(
    'category__in'   => $category_ids,
    'posts_per_page' => 3,
    'post_status'    => 'publish',
    'orderby'        => 'rand',
    'date_query'     => $date_query,
);

$random_posts = get_posts( $params );

// Если нашли посты
if ( $random_posts ) {
    // Выбираем случайный один из трёх
    $post = $random_posts[ array_rand( $random_posts ) ];
    setup_postdata( $post );
    ?>
    
    <div class="agro-widget<?php if ($args['subclass'] !== '') echo ' '.$args['subclass'];?>">
        <div class="agro-widget-maintitle"><a href="/rfo">СПЕЦПРОЕКТ<br>Фумигация и защита растений</a></div>
        <a href="<?php the_permalink(); ?>">
            <?php if ( has_post_thumbnail() ) : ?>
                <div>
                    <?php the_post_thumbnail('full'); ?>
                </div>
            <?php endif; ?>
            <h3 class="agro-widget-title"><?php the_title(); ?></h3>
        </a>
    </div>
    
    <?php
    wp_reset_postdata();
}